if (typeof $ === "undefined") { throw new Error("jQuery is required") }

Record.Group = function(args) {
  var superArguments = Array.prototype.slice.call(arguments);
  superArguments.unshift("group");
  Record.Generic.apply(this, superArguments);
}

Record.Group.prototype = Object.create(Record.Generic.prototype);
Record.Group.prototype.constructor = Record.Group;

Record.Group.prototype.fetch = function(callback) {
  var self = this;
  var id = this.id;

  async.parallel([
    this.attributes.bind(this),
    this.ownedResources.bind(this),
    function(cb) {
      $.ajax({
        url: "/api/authz/" + conjurConfiguration.account + "/roles/group/" + id + "?members",
        success: function(result) {
          cb(null, result);
        },
        error: cb
      });
    }
  ],
  function(err, results) {
    if ( err )
      return errback(err);

    callback({ group: results[0], owned: results[1], members: results[2] });
  });
}
