if (typeof $ === "undefined") { throw new Error("jQuery is required") }

Record.Layer = function(args) {
  var superArguments = Array.prototype.slice.call(arguments);
  superArguments.unshift("layer");
  Record.Generic.apply(this, superArguments);
}

Record.Layer.prototype = Object.create(Record.Generic.prototype);
Record.Layer.prototype.constructor = Record.Layer;

Record.Layer.prototype.fetch = function(callback) {
  var self = this;
  var id = this.id;

  function members(role) {
    return function(cb) {
      $.ajax({
        url: "/api/authz/" + conjurConfiguration.account + "/roles/" + role + "?members",
        success: function(result) { cb(null, result) },
        error: cb
      });
    }
  }

  async.parallel([
    this.attributes.bind(this),
    this.ownedResources.bind(this),
    members('@/layer/' + id + '/use_host'),
    members('@/layer/' + id + '/use_host')
  ],
  function(err, results) {
    if ( err )
      return errback(err);

    callback({ layer: results[0], owned: results[1], users: _.pluck(results[2], 'member'), admins: _.pluck(results[3], 'member') });
  });
}
